#### POSIX Threads for Windows – REFERENCE - Pthreads-w32

Reference Index

Table of Contents

## Name

pthread_rwlock_unlock - unlock a read-write lock object

## Synopsis

#include <pthread.h>

int pthread_rwlock_unlock(pthread_rwlock_t *rwlock);

## Description

The pthread_rwlock_unlock function shall release a lock held on the read-write lock object referenced by rwlock. Results are undefined if the read-write lock rwlock is not held by the calling thread.

If this function is called to release a read lock from the read-write lock object and there are other read locks currently held on this read-write lock object, the read-write lock object remains in the read locked state. If this function releases the last read lock for this read-write lock object, the read-write lock object shall be put in the unlocked state with no owners.

If this function is called to release a write lock for this read-write lock object, the read-write lock object shall be put in the unlocked state.

Pthreads-win32 does not prefer either writers or readers in acquiring the lock – all threads enter a single prioritised FIFO queue. While this may not be optimally efficient for some applications, it does ensure that one type does not starve the other.

Results are undefined if any of these functions are called with an uninitialized read-write lock.

Pthreads-w32 defines _POSIX_READER_WRITER_LOCKS in pthread.h as 200112L to indicate that the reader/writer routines are implemented and may be used.

## Return Value

If successful, the pthread_rwlock_unlock function shall return zero; otherwise, an error number shall be returned to indicate the error.

## Errors

The pthread_rwlock_unlock function may fail if:

EINVAL
  The value specified by rwlock does not refer to an initialized read-write lock object.

The pthread_rwlock_unlock function shall not return an error code of [EINTR].

The following sections are informative.

## Examples

None.

## Application Usage

None.

## Rationale

None.

## Future Directions

None.

## See Also

pthread_rwlock_destroy(3) , pthread_rwlock_rdlock(3) , pthread_rwlock_timedrdlock(3) , pthread_rwlock_timedwrlock(3) , pthread_rwlock_tryrdlock(3) , pthread_rwlock_trywrlock(3) , pthread_rwlock_wrlock(3) , the Base Definitions volume of IEEE Std 1003.1-2001, <pthread.h>

## Copyright

Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .

Modified by Ross Johnson for use with Pthreads-w32.

Table of Contents

- Name

- Synopsis

- Description

- Return Value

- Errors

- Examples

- Application Usage

- Rationale

- Future Directions

- See Also

- Copyright